Subject: Re: bug#47243: pr lacks -p

From: Pádraig Brady <[email-masked]>
Date: Mon, 28 Jul 2025 17:23:30 +0100

On 28/07/2025 17:06, Stan Marsh wrote:
> Paul wrote:
> 
>> Then    Pádraig Brady wrote:
>>> Reading POSIX more closely I see there is also pause logic for the first page
>>> only:
>>>   -f    [XSI] [Option Start] Use a <form-feed> for new pages, instead of the
> -------------------------------^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ (!)
>>> default
>>> behavior that uses a sequence of <newline> characters.
>>>         Pause before beginning the first page if the standard output is
>>> associated with a terminal. [Option End]
> 
>>> How can it be both?
> 
> Then Paul wrote:
> 
>> If neither -p nor -f is specified, pr doesn't pause.
> 
>> If -p is specified, pr pauses before every output page, regardless of whether -f is
>> also specified.
> 
>> If -f but not -p is specified, pr pauses only before the first output page.
> 
> I think there is a misunderstanding here.
> 
> The point is that -f is already taken; it is a synonym for -F.
> 
> So, it can't be re-purposed to mean: pause only before the first output page,
> without breaking any script or human who depends on it meaning: use form feeds.

Yes it's a fair point.
We don't want existing scripts that use -f to start pausing unexpectedly.
I suppose this is a case for only pausing with -f if POSIXLY_CORRECT
env var is set.

cheers,
Padraig